//----------------------------------------------------------------------------------
// aviutl  GPUF␳tB^ vt@Cp
// Copyright (c) 2006-2008  N099
//----------------------------------------------------------------------------------
#pragma once

//ptH[}Xp
#ifdef PROFILE_GPU
enum EProf { INIT, CACHE, PUT_GPU, PROC_GPU, WB_GPU, CPY_RES, GPU_RSZ, NUM_EP };

struct PCount {
	bool valid1st;
	const TCHAR* tag;
	LARGE_INTEGER c[4];
};

class CProf {
public:
	CProf(void* p);
	~CProf();
	void CountEnt(EProf e);
	void CountLea(EProf e);
	void Print();
private:
	HWND m_debugWnd;
	PCount m_PCnt[NUM_EP];
	CRITICAL_SECTION m_cs;
};

void CountEnt(EProf e);
void CountLea(EProf e);
void PrintCount();

#else

#define CountEnt(e)
#define CountLea(e)
#define PrintCount()

#endif

//for debug
#ifdef _DEBUG
#include <crtdbg.h>
void SetMemDbg();
//#define new(a) new(_CLIENT_BLOCK, __FILE__, __LINE__)
#else
#define SetMemDbg()
#endif
